#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Nov 10 18:14:00 2022
one day daa in one map
用于从 

@author: chashan
"""

import numpy as np
import matplotlib.pyplot as plt
import matplotlib.dates as mdates
from matplotlib.ticker import MultipleLocator
import matplotlib.cm as mplcm

import os
from fnmatch import fnmatch
import time
import datetime
from astropy.io import fits
import cv2
import rebin

def file_search( fn , subdir = 0 ) :
    findfiles = []
    allv = 0
    if subdir == 1 :
       allv = 1
    ## split dir  and base name
    target_dir, infname = os.path.split( fn )
    if len(target_dir) == 0 :
        target_dir = './'
    ## check dir
    walk_generator = os.walk(target_dir)
    for root_path, dirs, files in walk_generator :
        if allv ==1 :
            if len(files) < 1:
                continue
            for file in files:
               if fnmatch( file, infname ) :
                  findfiles.append(os.path.join(root_path, file ))
        else :
            if  fnmatch( root_path, target_dir ) :
                if len(files) < 1:
                   continue
                for file in files:
                   if fnmatch( file, infname ) :
                      findfiles.append(os.path.join(root_path, file ))
    findfiles.sort()
    return findfiles
def bytscalx(dataxx, minv=1, maxv=5):
    datacc =    (dataxx - minv)/ (maxv - minv) * 255 
    index = np.where(datacc < 0)
    if len(index[0]) > 0:
        datacc[index] = 0
    index = np.where(datacc > 255)
    if len(index[0]) > 0:
        datacc[index] = 255
    dataB = np.zeros( datacc.shape , dtype='u1')
    dataB[:,:] =  datacc 
    return dataB

def filename2time( fn ):
    nfile = len(fn)
    tfilename = []
    for ii in range(nfile) :
        ss = os.path.basename(fn[ii])
        tfile = datetime.datetime( int(ss[25:29]),int(ss[29:31]),int(ss[31:33]),
                                  int(ss[33:35]),int(ss[35:37]),int(ss[37:39]) )
        tfilename.append(tfile)
    return tfilename

###### 从 fits 文件中 提取数据
def pulloutDatfits( fnamex ) :
    nfname = len( fnamex )
    if nfname < 1 :
        print('no fitsfile to read!')
        return [],[],[]
    hdux = fits.open( fnamex[0])
    tx = np.ravel(hdux[1].data['time'])
    ffxx = np.ravel(hdux[1].data['frequency'])
    datac = hdux[0].data
    hdux.close()
    if nfname > 1:
       for ii in range(1, nfname):
           hdux = fits.open( fnamex[ii])
           txii = np.ravel(hdux[1].data['time'])
           ffxxii = np.ravel(hdux[1].data['frequency'])
           datacii = hdux[0].data
           hdux.close()  
           tx = np.hstack( (tx, txii) )
           ffxx = np.hstack( ( ffxx,ffxxii ) )
           datac = np.r_['2',datac, datacii]
           
    
    return tx, ffxx, datac



###-----------------------------------------------------------
##########################################
##########################################################
if 1==1:
    datet1s ='2025-01-31T07:40:00'
    datet2s ='2025-01-31T07:41:30'
    # datet1s ='2024-05-03T02:18:00'
    # datet2s ='2024-05-03T02:23:00'
    # datet1s ='2024-05-03T23:28:00'
    # datet2s ='2024-05-03T23:32:00'
    f1=  90
    f2 = 350
    tbin= 10
    fbin= 1
    pols = 'RR'
    nmin = 30 #### 分钟
    nsec = 1 ###  秒间隔

    scalemethod  = 'log10'
    minv = 2.0
    maxv = 4.50
    
    
    nows = datetime.datetime.now()
    print(nows.isoformat() + '  start work......')
    
    
    t1 = datetime.datetime.fromisoformat( datet1s )
    t2 = datetime.datetime.fromisoformat( datet2s )
    dateobs0 = datetime.datetime(t1.year,t1.month,t1.day,0,0,0) 
    if t1.hour > 20 :
        dateobs0 = dateobs0 + datetime.timedelta(days=1)
    dts1 = t1 - dateobs0
    dts2 = t2 - dateobs0     
    ts1 = dts1.total_seconds()
    ts2 = dts2.total_seconds()
    if ts1 > ts2 :
        print('time is wrong!!')

    ##### dirs 
    if 1==1 :
        sduDir = '/home/data0/OROCH/MWRSsdu/'
        dates = dateobs0.strftime('%Y%m%d')
    
        ### 构造输入输出目录
        dateddss = dates[0:4] +'/' + dates[4:6] + '/' + dates +'/'
        outdir = sduDir + dateddss + 'synthesis/'
        os.makedirs( outdir, mode=511, exist_ok = True )
        if os.path.exists(outdir) != True :
             print('no outdir')
        innamefits = file_search( sduDir + dateddss  + 'fits/*.fits' )
    else:
        innamefits = file_search(' *.fits')
        outdir = './'
    
    
    nfits = len( innamefits )
    dfitstime = [  kk - dateobs0  for kk in filename2time( innamefits ) ]
    dfitsts = np.array( [dfitstime[ii].total_seconds() for ii in range(nfits)] )
    ## 查找需要的文件包
    index = np.where( dfitsts <= ts1 )
    if len( index[0] ) > 0 :
        fnindex1 = index[0][-1]
    else:
        fnindex1 = 0
    index = np.where( dfitsts >= ts2 )
    if len( index[0] ) > 0 :
        fnindex2 = index[0][0]
    else:
        fnindex2 = nfits
        
    ##### 如果只有一个包 === 
    if fnindex1 == fnindex2 :
        fnindex2 += 1
        
    #### 选取 文件名    
    fnamex = innamefits[fnindex1:fnindex2]
    
    # fnamex = [innamefits[2]]
    print( fnamex )
    
    
    
    ### 提取数据
    tx, ffxx, datac = pulloutDatfits( fnamex )  
    jpgname = outdir + 'SynRadiospec_CSO_' + t1.strftime('%Y%m%d%H%M%S') +'-'+ t2.strftime('%Y%m%d%H%M%S') + pols + '.jpg'
    
    
    nt = len(tx)
    nff= len(ffxx)
    
    #########抽取数据================
    index = np.where( tx >= ts1 )
    if len(index[0])>0:
        tindex1 = index[0][0]
    else :
        tindex1 = 0
    index = np.where( tx >= ts2 )    
    if len(index[0])>0:
         tindex2 = int( index[0][0] + 1 )       
    else :
         tindex2 = nt
         
    index = np.where( ffxx >= f1 )
    if len(index[0])>0:
        findex1 = index[0][0]
    else :
        findex1 = 0
    index = np.where( ffxx >= f2 )    
    if len(index[0])>0:
         findex2 = int( index[0][0] + 1 )       
    else :
         findex2 = nff
    ### 数据切片
    tx = tx[tindex1:tindex2]
    ffxx = ffxx[findex1:findex2]
    nt = len(tx)
    nff= len(ffxx)   
    datacx = datac[:,findex1:findex2, tindex1:tindex2]


    nows = datetime.datetime.now()
    print(nows.isoformat() + '  start plot work!!!!')
    databin =   rebin.rebin( datacx,  factor=( 1, fbin, tbin )  )  
    ttt = rebin.rebin( tx,  factor=( tbin, )  )  
    fffxx = rebin.rebin( ffxx,  factor=( fbin, )  )  
    
    nt = len(ttt)
    nff = len(fffxx)

    s2 = dateobs0 + datetime.timedelta( seconds = ttt[0] )
    s3 = dateobs0 + datetime.timedelta( seconds = ttt[-1] )
        

    #### scale data  ================================
    ZZx = databin    ### np.zeros_like( Z0 )
    if scalemethod  == 'log10' :
       ZZx[ZZx <1] = 1.0
       ZZ = np.log10( ZZx )
       Z0 = ZZ[0,:,:]
       Z1 = ZZ[1,:,:]
    else :
       Z0 = ZZx[0,:,:]
       Z1 = ZZx[1,:,:]
 
    #######==============================================
    #  
    # months = s2.strftime('%b')
    # datess = s2.strftime('%d') +  ' '+ months.upper() + ' ' + s2.strftime('%Y')
    # titles = 'Quick-look of solar radio spectrum (SRSQ) OROCH (122.31E, 36.84N) ' +  datess
    ffranges = '({:d}-{:d}MHz)'.format( int(np.round(ffxx[0])), int(np.round(ffxx[-1])) )
    t12t2s = s2.strftime('%Y-%m-%dT%H:%M:%SUT') + ' to ' + s3.strftime('%Y-%m-%dT%H:%M:%SUT')
    # titles = 'CSO CBSm Spectrograph '+ pols + ' ' +  ffranges + ' Period: '  +  t12t2s 
    
    t1ss = s2.strftime('%Y-%m-%d')
    titles = 'CSO CBSm Spectrograph '+ pols + ' ' +   t1ss 
    dt21 = s3 - s2
    utss = 'UT'
    dt21sec = dt21.total_seconds()
    if dt21sec  < 300 :
        utss = ' from ' + s2.strftime('%H:%M:%S') + ' UT '

    # xlabes = 'Time (' + utss + ')' 
    xlabes = 'Time (UT)' 
    
    jcmap = mplcm.get_cmap("jet")
    # jcmap.set_over(color = 'w')
 
    
 
    setfontsize = 300.0   
    wx = 10000
    hy = 6000
 
    xi = 5
    uy = 200 * xi
    dy = 300 * xi
    qx = 300 * xi
    hx = 200 * xi
   

    
    # setfontsize = 20.0
    
    # if nt < 1000 :
    #     nt = 1000

    # hy = nff  #8180 #2300 409
    # if nff <  1000 :
    #     hy = 1000
    
    # wx = nt
    # qx = 300
    # hx = 200
    # # hy = 2000
    # uy = 200
    # dy = 300

    widthh = qx + wx + hx
    height = dy + hy + uy

      
    ####
    pos1 =[0.0,0.0,1.0,1.0]
    pos1[0] = (qx + 0.0) / widthh
    pos1[1] = (dy +0.0 ) / height
    pos1[2] = (wx + 0.0) / widthh
    pos1[3] = (hy + 0.0) / height
    

    posbar =[0.0,0.0,1.0,1.0]
    posbar[0] = (qx + wx + 60.0) / widthh
    posbar[1] = (dy + 0.0) / height
    posbar[2] = (80.0) / widthh
    posbar[3] = (hy + 0.0) / height
    

    fig, ax = plt.subplots(1, 1, sharex=True,figsize=(widthh/100.0,height/100.0),dpi=100)
    #  ½øÈë»­Í¼²¿·Ö
    # ss = dateobs0.ctime()
    # titles = 'Quick-look of solar radio spectrum (SRSQ) OROCH (122.31E, 36.84N)  ' + ss[4:10] +' '+ ss[20:24] 
    # fig.suptitle(titles, x= pos1[0],  y= pos1[1] + pos1[3]+0.001, fontsize= setfontsize)

    xx, yy = np.meshgrid(ttt, fffxx)               
    fr = [fffxx[0],fffxx[-1]]     
    xr = [ttt[0],ttt[-1]]     

     
    #### plot Right or first  
    ax1 = ax 
    ax1.set_position( pos1 ) 
                     
    ax1.set_ylabel('Frequency (MHz)',fontsize = setfontsize )
    ax1.set_xlabel( xlabes, fontsize = setfontsize )
    # ax1.set_title( 'RCP',fontsize = setfontsize, loc = 'right')
    ax1.set_title( titles, fontsize = setfontsize, loc = 'center')
    ax1.set_xlim([s2, s3])
    ax1.set_ylim( fr )
                       #ax.xticks(rotation=70)
    # ax1.xaxis.set_major_Locator( mdates.MinuteLocator(interval = 2 ))    
    # ax1.xaxis.set_major_locator( mdates.MinuteLocator(interval= nmin ) )
    ax1.xaxis.set_major_locator( mdates.SecondLocator(interval= nmin ) )
    ax1.xaxis.set_minor_locator( mdates.SecondLocator(interval = nsec ) )
    
    
    
    
    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
             
    # if dt21sec < 60 :
    #    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%S'))
    # elif dt21sec > 60 and dt21sec < 300  :
    #    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%M:%S'))
    # else :                   
    #    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M'))
    # # ax1.xaxis.set_minor_locator(mdates.SecondLocator() )
    # # ax1.xaxis.set_major_locator(mdates.MinuteLocator() )
    
    ax1.yaxis.set_minor_locator(MultipleLocator(10))
    # ax1.xaxis.set_minor_locator(MultipleLocator(5))
    
    ax1.tick_params(direction='out',  left=True, right=False)
    ax1.tick_params(axis='x', labelsize= setfontsize )
    ax1.tick_params(axis='y', labelsize= setfontsize  )
    ax1.tick_params( which='minor', length=20, width =5)
    ax1.tick_params( which='major', length=40, width =10 ) 

    ax1in1 = ax1.inset_axes([0.0, 0.0, 1, 1])
    # ax1in1.plot( np.array([ 155, 155]), np.array( xr ) , 'w--',zorder=4)
    # maxv = np.max(Z0)
    if pols == 'LL' :
        psm1 = ax1in1.pcolormesh(xx, yy, Z1, vmin=minv, vmax=maxv,cmap =jcmap, rasterized=True, zorder=3)
    else :
        psm1 = ax1in1.pcolormesh(xx, yy, Z0, vmin=minv, vmax=maxv,cmap =jcmap, rasterized=True, zorder=3)

    
    ax1in1.axis('off')
    

    cax = fig.add_axes( posbar )
    bar1 = plt.colorbar(psm1, cax = cax)
    bar1.ax.text(0, maxv+(maxv-minv)/50 , 'log10',fontsize = setfontsize *0.8) 
    bar1.ax.tick_params(direction='out', labelsize=setfontsize*0.8 , right=True)
    bar1.ax.tick_params( which='major', length=10)

    fig.savefig(jpgname)


    if 1==0 :

        pols = 'LL'
        jpgname = outdir + 'SynRadiospec_CSO_' + t1.strftime('%Y%m%d%H%M%S') +'-'+ t2.strftime('%Y%m%d%H%M%S') + pols + '.jpg'
        
        
        titles = 'CSO Spectrograph '+ pols + ' ' +  ffranges + ' Period: '  +  t12t2s 
        fig, ax = plt.subplots(1, 1, sharex=True,figsize=(widthh/100.0,height/100.0),dpi=100)
        #  ½øÈë»­Í¼²¿·Ö
        # ss = dateobs0.ctime()
        # titles = 'Quick-look of solar radio spectrum (SRSQ) OROCH (122.31E, 36.84N)  ' + ss[4:10] +' '+ ss[20:24] 
        # fig.suptitle(titles, x= pos1[0],  y= pos1[1] + pos1[3]+0.001, fontsize= setfontsize)
    
        xx, yy = np.meshgrid(ttt, fffxx)               
        fr = [fffxx[0],fffxx[-1]]     
        xr = [ttt[0],ttt[-1]]     
    
         
        #### plot Right or first  
        ax1 = ax 
        ax1.set_position( pos1 ) 
                         
        ax1.set_ylabel('Frequency (MHz)',fontsize = setfontsize )
        ax1.set_xlabel('Time (UT)',fontsize = setfontsize )
        # ax1.set_title( 'RCP',fontsize = setfontsize, loc = 'right')
        ax1.set_title( titles, fontsize = setfontsize, loc = 'center')
        ax1.set_xlim([s2, s3])
        ax1.set_ylim( fr )
                           #ax.xticks(rotation=70)
                           
                           
        ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
        ax1.xaxis.set_minor_locator(mdates.SecondLocator() )
        ax1.xaxis.set_major_locator(mdates.MinuteLocator() )
        ax1.yaxis.set_minor_locator(MultipleLocator(10))
        # ax1.xaxis.set_minor_locator(MultipleLocator(5))
        
        ax1.tick_params(direction='out',  left=True, right=False)
        ax1.tick_params(axis='x', labelsize= setfontsize )
        ax1.tick_params(axis='y', labelsize= setfontsize  )
        ax1.tick_params( which='minor', length=20, width =5)
        ax1.tick_params( which='major', length=40, width =10 ) 
    
        ax1in1 = ax1.inset_axes([0.0, 0.0, 1, 1])
        # ax1in1.plot( np.array([ 155, 155]), np.array( xr ) , 'w--',zorder=4)
        # maxv = np.max(Z0)
    
        psm1 = ax1in1.pcolormesh(xx, yy, Z1, vmin=minv, vmax=maxv,cmap =jcmap, rasterized=True, zorder=3)
        
        
        ax1in1.axis('off')
        
    
        cax = fig.add_axes( posbar )
        bar1 = plt.colorbar(psm1, cax = cax)
        bar1.ax.text(0, maxv+(maxv-minv)/100, 'log10',fontsize = setfontsize *0.8) 
        bar1.ax.tick_params(direction='out', labelsize=setfontsize*0.8 , right=True)
        bar1.ax.tick_params( which='major', length=10)
    
        fig.savefig(jpgname)
    
    














